#!/usr/bin/python

## groupDialog - event handling code for userconf's group dialog
## Copyright (C) 2001 Red Hat, Inc.
## Copyright (C) 2001 Brent Fox <bfox@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

## Author: Brent Fox

from gtk import *
from gnome.ui import *
import string
import gnome.help
import gnome.config
import libuser
import checklist
import mainWindow

class groupDialog:

    def __init__(self, parent, xml):
        self.parent = parent
        self.groupDialog = xml.get_widget('groupDialog')
        self.groupDialog.close_hides(TRUE)
        self.existingRadio = xml.get_widget('existingRadio')
        self.usersRadio = xml.get_widget('usersRadio')

        xml.signal_autoconnect (
            { "on_groupOkButton_clicked" : self.on_groupOkButton_clicked,
              })

    def showDialog(self, userEnt, userName):
        self.userEnt = userEnt
        self.userName = userName
        self.groupDialog.show_all()

    def on_groupOkButton_clicked(self, *args):
        if self.existingRadio.get_active():
            groupEnt = self.parent.parent.ADMIN.lookupGroupByName(self.userName)
            cn = groupEnt.get(libuser.GROUPNAME)[0]
            
            gidNumber = groupEnt.get(libuser.GIDNUMBER)[0]
            self.userEnt.set(libuser.GIDNUMBER, gidNumber)
            self.parent.parent.ADMIN.modifyUser(self.userEnt)
            members = groupEnt.get(libuser.MEMBERUID)
            if not members:
                members = []

#            members.append(self.userName)
#            groupEnt.set(libuser.MEMBERUID, members)
#            self.parent.parent.ADMIN.modifyGroup(groupEnt)
            
        else:
            groupEnt = self.parent.parent.ADMIN.lookupGroupByName('users')
            cn = groupEnt.get(libuser.GROUPNAME)[0]
            
            gidNumber = groupEnt.get(libuser.GIDNUMBER)[0]
            self.userEnt.set(libuser.GIDNUMBER, gidNumber)
            self.parent.parent.ADMIN.modifyUser(self.userEnt)
            members = groupEnt.get(libuser.MEMBERUID)
            if not members:
                members = []

            members.append(self.userName)
            groupEnt.set(libuser.MEMBERUID, members)
            self.parent.parent.ADMIN.modifyGroup(groupEnt)

        self.parent.parent.refresh_users_and_groups([self.userName, 'users'])
        self.parent.parent.refresh_users_and_groups(cn)
           
        self.groupDialog.hide()
        self.parent.userWin.hide()
