#!/usr/bin/python

## groupWindow - event handling code for userconf's group window
## Copyright (C) 2001 Red Hat, Inc.
## Copyright (C) 2001 Brent Fox <bfox@redhat.com>

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

## Author: Brent Fox

import signal
import gtk
import gnome.ui
import libglade
from gtk import *
from gnome.ui import *
import string
import libuser

class groupWindow:

    def __init__(self, parent, user_clist, group_clist, xml):
        self.parent = parent
        self.group_clist = group_clist
        
        self.groupWin = xml.get_widget('newGroupWindow')
        self.groupWin.close_hides(TRUE)
        self.groupWinGroupName = xml.get_widget('newGroupNameEntry')
        self.group_clist.set_column_visibility(1, FALSE)

        xml.signal_autoconnect (
            { "on_groupWin_cancel_button_clicked" : self.on_groupWin_cancel_button_clicked,
              "on_groupWin_ok_button_clicked" : self.on_groupWin_ok_button_clicked,
              })

    def groupWinReset(self):
        self.groupWinGroupName.grab_focus()
        self.groupWinGroupName.set_text("")

    def newGroupWin(self):
        self.groupWinReset()
        self.groupWin.show_all()
        
    #--------Event handlers for group window-----#
    def on_groupWin_cancel_button_clicked(self, *args):
        self.groupWinReset()
        self.groupWin.hide()

    def on_groupWin_ok_button_clicked(self, *args):
        groupName = self.groupWinGroupName.get_text()

        if groupName == "":
            dlg = GnomeMessageBox("Please enter a group name.",
                                  MESSAGE_BOX_ERROR, STOCK_BUTTON_OK, None)
            dlg.run_and_close()
            return

        group = self.parent.ADMIN.lookupGroupByName(groupName)
        if group != None:
            dlg = GnomeMessageBox("A group with name '%s' already exists." %groupName,
                                  MESSAGE_BOX_ERROR, STOCK_BUTTON_OK, None)
            dlg.run_and_close()
            return

        groupEnt = self.parent.ADMIN.initGroup(groupName)
        cn = groupEnt.get(libuser.GROUPNAME)[0]
        gid = groupEnt.get(libuser.GIDNUMBER)[0]
        members = groupEnt.get(libuser.MEMBERUID)
        if not members:
            members = []
        memberlist = string.join(members, ", ")

        self.parent.ADMIN.addGroup(groupEnt)
        
        self.groupWinReset()
        self.groupWin.hide()

        self.parent.refresh_users_and_groups(cn)
